/*
Problem: database
Contest: UOI 2012
Solution: Optimal O(N + M + K)
Author: Andrii Korotkov
*/

#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

#define N 50005

const int RIGHTS_FROM_ADMIN = 0;
const int NO_RIGHTS_FROM_ADMIN = 1;
const int RIGHTS_TO_SUBORDINATES = 2;
const int RIGHTS_TO_SUBORDINATES_RECURSIVELY = 3;
const int NO_RIGHTS_TO_SUBORDINATES = 4;

int n,m,k;
vector<int> a[N],top;
bool used[N];
int last[N][5];
int x,y,t;
int ans[N];

void dfs(int v)
{
	used[v] = 1;
	for(int i = 0; i < a[v].size(); ++i)
		if(!used[a[v][i]])
			dfs(a[v][i]);
	top.push_back(v);
}

int main()
{
	freopen("database.dat","r",stdin);
	freopen("database.sol","w",stdout);
	scanf("%d%d",&n,&m);
	for(int i = 0; i < m; ++i)
	{
		scanf("%d%d",&x,&y);
		--x, --y;
		a[y].push_back(x);
	}
	scanf("%d",&k);
	for(int i = 0; i < k; ++i)
	{
		scanf("%d%d",&t,&x);
		--t, --x;
		last[x][t] = i + 1;
	}
	for(int i = 0; i < n; ++i)
		if(!used[i])
			dfs(i);
	for(int i = 0; i < n; ++i)
	{
		int v = top[i];
		for(int j = 0; j < a[v].size(); ++j)
			last[v][RIGHTS_TO_SUBORDINATES_RECURSIVELY] = max(last[v][RIGHTS_TO_SUBORDINATES_RECURSIVELY], last[a[v][j]][RIGHTS_TO_SUBORDINATES_RECURSIVELY]);
		ans[v] |= (last[v][RIGHTS_FROM_ADMIN] > last[v][NO_RIGHTS_FROM_ADMIN]); // this include last[v][RIGHTS_FROM_ADMIN] == 0
		for(int j = 0; j < a[v].size(); ++j)
			ans[v] |= (ans[a[v][j]] && (max(last[a[v][j]][RIGHTS_TO_SUBORDINATES],last[a[v][j]][RIGHTS_TO_SUBORDINATES_RECURSIVELY]) > last[a[v][j]][NO_RIGHTS_TO_SUBORDINATES]));
	}
	for(int i = 0; i < n; ++i)
	{
		printf("%d%c", ans[i], i < n-1 ? ' ' : '\n');
	}
	return 0;
}