{
Problem: database
Contest: UOI 2012
Solution: Optimal O(N + M + K)
Author: Andrii Korotkov
}
{$APPTYPE CONSOLE}
{$B-,R-,O+}
const
  RIGHTS_FROM_ADMIN = 0;
  NO_RIGHTS_FROM_ADMIN = 1;
  RIGHTS_TO_SUBORDINATES = 2;
  RIGHTS_TO_SUBORDINATES_RECURSIVELY = 3;
  NO_RIGHTS_TO_SUBORDINATES = 4;
  NN = 10005;
  MM = 50005;

type
  tlist = record
    v,next:longint;
  end;

var
  n,m,k,i,j,lp,top,v:longint;
  a,tps:array[0..NN] of longint;
  l:array[0..NN+MM] of tlist;
  used:array[0..NN] of boolean;
  last:array[0..NN, 0..4] of integer;
  x,y,t:integer;
  ans:array[0..NN] of boolean;

function max(a,b:longint):longint;
begin
  if(a > b) then
    max:=a else
    max:=b;
end;

procedure init_variables;
begin   
  fillchar(used,sizeof(used),0);
  fillchar(l,sizeof(l),0);
  fillchar(a,sizeof(a),0);
  top := 0;
  fillchar(last,sizeof(last),0);
  fillchar(ans,sizeof(ans),0);
  lp := 1;
end;

procedure add_edge(var a:longint;y:integer);
begin
  l[lp].v := y;
  l[lp].next := a;
  a := lp;
  inc(lp);
end;

procedure dfs(v:integer);
var
  i: longint;
begin
	used[v] := true;
  i := a[v];
	while(i <> 0) do
  begin
		if(not used[l[i].v])then
			dfs(l[i].v);
    i := l[i].next;
  end;
	add_edge(top,v);
end;

begin
	assign(input,'database.dat');
	assign(output,'database.sol');
  reset(input);
  rewrite(output);
  init_variables;
	read(n,m);
	for i:=0 to m-1 do
	begin
		read(x,y);
		dec(x); dec(y);
		add_edge(a[y], x);
	end;
	read(k);
	for i := 0 to k-1 do
	begin
		read(t,x);
		dec(t); dec(x);
		last[x][t] := i + 1;
	end;
	for i := 0 to n-1 do
		if(not used[i])then
			dfs(i);
  j := n-1;
  i := top;
  while(i <> 0) do
  begin
    tps[j] := l[i].v;
    dec(j);
    i := l[i].next;
  end;
	for i:=0 to n-1 do
	begin
		v := tps[i];
    j := a[v];
    while(j <> 0) do
    begin
			last[v][RIGHTS_TO_SUBORDINATES_RECURSIVELY] := max(last[v][RIGHTS_TO_SUBORDINATES_RECURSIVELY], last[l[j].v][RIGHTS_TO_SUBORDINATES_RECURSIVELY]);
      j := l[j].next;
    end;
		ans[v] := ans[v] or (last[v][RIGHTS_FROM_ADMIN] > last[v][NO_RIGHTS_FROM_ADMIN]); // this include last[v][RIGHTS_FROM_ADMIN] == 0
		j := a[v];
    while(j <> 0) do
    begin
			ans[v] := ans[v] or (ans[l[j].v] and (max(last[l[j].v][RIGHTS_TO_SUBORDINATES],last[l[j].v][RIGHTS_TO_SUBORDINATES_RECURSIVELY]) > last[l[j].v][NO_RIGHTS_TO_SUBORDINATES]));
      j := l[j].next;
    end;
	end;
	for i := 0 to n-1 do
	begin
		write(longint(ans[i]));
    if(i < n-1)then
      write(' ') else
      writeln;
	end;
  close(input);
  close(output);
end.
 
